=== debian/changelog ===
ocaml-ctypes (0.2.3-1build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 04 Nov 2015 11:41:24 -0600

ocaml-ctypes (0.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #742613)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 25 Mar 2014 15:47:23 +0100
