=== debian/control ===
Source: ocaml-ctypes
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 9),
 libffi-dev,
 libounit-ocaml-dev,
 ocaml-findlib,
 ocaml-nox (>= 4.00.0),
 dh-ocaml
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-ctypes.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-ctypes.git
Homepage: https://github.com/ocamllabs/ocaml-ctypes

Package: libctypes-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: library for binding to C libraries using pure OCaml (runtime)
 The ocaml-ctypes library makes it possible to call C functions
 directly from OCaml without writing or generating C code.  The core
 of the library is a set of combinators for describing C types --
 scalars, functions, structs, unions, arrays, and pointers to values
 and functions.  Type descriptions can then be used to bind native
 functions and values.
 .
 This package contains the shared runtime stub library and plugins.

Package: libctypes-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: library for binding to C libraries using pure OCaml (dev)
 The ocaml-ctypes library makes it possible to call C functions
 directly from OCaml without writing or generating C code.  The core
 of the library is a set of combinators for describing C types --
 scalars, functions, structs, unions, arrays, and pointers to values
 and functions.  Type descriptions can then be used to bind native
 functions and values.
 .
 This package contains all the development stuff you need to use
 ocaml-ctypes.
