=== debian/watch ===
version=3
https://github.com/ocamllabs/ocaml-ctypes/releases/ocaml-ctypes-(.*)\.tar\.gz
