=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ocaml-ctypes
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper (>= 9),
@@ -9,10 +10,11 @@
  libounit-ocaml-dev,
  ocaml-findlib,
  ocaml-nox (>= 4.00.0),
+ liblwt-ocaml-dev,
  dh-ocaml
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-ctypes.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-ctypes.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
 Homepage: https://github.com/ocamllabs/ocaml-ctypes
 
 Package: libctypes-ocaml
