=== debian/rules ===
--- 
+++ 
@@ -24,4 +24,4 @@
 
 .PHONY: override_dh_install
 override_dh_install:
-	dh_install --fail-missing -X.so.owner
+	dh_install --fail-missing -X.so.owner -XCHANGES.md
