## ocaml-ctypes 0.15.1

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,12 @@
 .SECONDEXPANSION:
 
 BEST:=$(shell if ocamlopt > /dev/null 2>&1; then echo native; else echo byte; fi)
-DEBUG=false
+OPAQUE:=$(shell if ocamlopt -opaque 2>/dev/null; then echo -opaque; fi) 
+NO_KEEP_LOCS:=$(shell if ocamlopt -no-keep-locs 2>/dev/null; then echo -no-keep-locs; fi) 
+DEBUG=true
 COVERAGE=false
 OCAML=ocaml
-OCAMLFIND=ocamlfind
+OCAMLFIND=ocamlfind $(OCAMLFINDFLAGS)
 HOSTOCAMLFIND=$(OCAMLFIND)
 OCAMLDEP=$(OCAMLFIND) ocamldep
 OCAMLMKLIB=$(OCAMLFIND) ocamlmklib
@@ -14,12 +16,28 @@
 FOREIGN_PROJECTS=test-libffi ctypes-foreign-base ctypes-foreign-threaded ctypes-foreign-unthreaded
 STUB_PROJECTS=cstubs
 PROJECTS=$(BASE_PROJECTS) $(FOREIGN_PROJECTS) $(STUB_PROJECTS)
+DEP_DIRS=$(foreach project,$(PROJECTS),$($(project).dir))
 GENERATED=src/ctypes/ctypes_primitives.ml	\
           src/ctypes-foreign-base/libffi_abi.ml \
           src/ctypes-foreign-base/dl.ml		\
           src/ctypes-foreign-base/dl_stubs.c	\
           libffi.config				\
-          asneeded.config
+          asneeded.config                       \
+          discover				\
+          gen_c_primitives			\
+          gen_c_primitives.log			\
+          gen_libffi_abi			\
+	  src/configure/extract_from_c.cmi	\
+	  src/configure/extract_from_c.cmo	\
+	  src/configure/gen_c_primitives.cmi	\
+	  src/configure/gen_c_primitives.cmo	\
+	  src/configure/gen_libffi_abi.cmi	\
+	  src/configure/gen_libffi_abi.cmo	\
+	  src/discover/commands.cmi		\
+	  src/discover/commands.cmo		\
+	  src/discover/discover.cmi		\
+	  src/discover/discover.cmo
+
 OCAML_FFI_INCOPTS=$(libffi_opt)
 export CFLAGS DEBUG
 
@@ -39,15 +57,17 @@
 ctypes-foreign: ctypes-base $(FOREIGN_PROJECTS)
 ctypes-stubs: ctypes-base $(STUB_PROJECTS)
 
-clean:
+clean: clean-examples clean-tests
 	rm -fr _build
 	rm -f $(GENERATED)
 
 # ctypes subproject
-ctypes.public = ctypes_static ctypes_primitive_types unsigned signed ctypes_structs ctypes posixTypes ctypes_types
+ctypes.cmi_only = ctypes_static ctypes_primitive_types ctypes_structs cstubs_internals
+ctypes.public = lDouble complexL ctypes posixTypes ctypes_types
 ctypes.dir = src/ctypes
 ctypes.extra_mls = ctypes_primitives.ml
-ctypes.deps = str bigarray bytes
+ctypes.deps = bigarray bytes integers
+ctypes.linkdeps = integers_stubs
 ctypes.install = yes
 ctypes.install_native_objects = yes
 ifeq ($(XEN),enable)
@@ -58,11 +78,13 @@
 ctypes: $(ctypes.dir)/$(ctypes.extra_mls) $$(LIB_TARGETS)
 
 # cstubs subproject
-cstubs.public = cstubs_internals cstubs_structs cstubs cstubs_inverted
+cstubs.public = cstubs_structs cstubs cstubs_inverted
 cstubs.dir = src/cstubs
 cstubs.subproject_deps = ctypes
-cstubs.deps = str bytes
+cstubs.deps = str bytes integers
 cstubs.install = yes
+cstubs.install_native_objects = yes
+cstubs.extra_hs = $(package_integers_path)/ocaml_integers.h
 
 cstubs: PROJECT=cstubs
 cstubs: $(cstubs.dir)/$(cstubs.extra_mls) $$(LIB_TARGETS)
@@ -73,7 +95,7 @@
 ctypes-foreign-base.install_native_objects = yes
 ctypes-foreign-base.threads = no
 ctypes-foreign-base.dir = src/ctypes-foreign-base
-ctypes-foreign-base.deps = bytes
+ctypes-foreign-base.deps = bytes integers
 ctypes-foreign-base.subproject_deps = ctypes
 ctypes-foreign-base.extra_mls = libffi_abi.ml dl.ml
 ctypes-foreign-base.extra_cs = dl_stubs.c
@@ -93,6 +115,7 @@
 ctypes-foreign-threaded.link_flags = $(libffi_lib) $(lib_process)
 ctypes-foreign-threaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
 ctypes-foreign-threaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
+ctypes-foreign-threaded.cmi_opts = $(OPAQUE) $(NO_KEEP_LOCS)
 ctypes-foreign-threaded.install_native_objects = no
 
 ctypes-foreign-threaded: PROJECT=ctypes-foreign-threaded
@@ -107,6 +130,7 @@
 ctypes-foreign-unthreaded.link_flags = $(libffi_lib) $(lib_process)
 ctypes-foreign-unthreaded.cmo_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
 ctypes-foreign-unthreaded.cmx_opts = $(OCAML_FFI_INCOPTS:%=-ccopt %)
+ctypes-foreign-unthreaded.cmi_opts = $(OPAQUE) $(NO_KEEP_LOCS)
 ctypes-foreign-unthreaded.install_native_objects = no
 
 ctypes-foreign-unthreaded: PROJECT=ctypes-foreign-unthreaded
@@ -116,7 +140,7 @@
 ctypes-top.public = ctypes_printers
 ctypes-top.dir = src/ctypes-top
 ctypes-top.install = yes
-ctypes-top.deps = compiler-libs
+ctypes-top.deps = compiler-libs integers
 ctypes-top.subproject_deps = ctypes
 ctypes-top.install_native_objects = yes
 
@@ -148,9 +172,9 @@
 
 # dependencies
 depend: configure
-	$(OCAMLDEP) $(foreach project,$(PROJECTS),-I $($(project).dir)) \
+	$(OCAMLDEP) -one-line $(foreach dir,$(DEP_DIRS),-I $(dir)) \
             $(shell find src examples -name '*.mli' -o -name '*.ml') \
-           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" > .depend
+           | sed "s!src/!_build/src/!g; s!examples/!_build/examples/!g" | sort > .depend
 
 #installation
 META-install:
@@ -174,7 +198,7 @@
 DOCFILES=$(foreach project,$(PROJECTS),\
            $(foreach mli,$($(project).public),\
             $($(project).dir)/$(mli).mli))
-DOCFLAGS=$(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))
+DOCFLAGS=-I $(shell ocamlfind query integers) $(foreach project,$(PROJECTS),-I $(BUILDDIR)/$($(project).dir))
 # Avoid passing duplicate interfaces to ocamldoc.
 DOCFILES:=$(filter-out src/ctypes-foreign-threaded/foreign.mli,$(DOCFILES))
 
@@ -198,7 +222,7 @@
 	@echo " For example, if libffi is installed in /opt/local, you can type:"
 	@echo
 	@echo "   export LIBFFI_CFLAGS=-I/opt/local/include"
-	@echo "   export LIBFFI_LIBS=-L/opt/local/lib"
+	@echo "   export LIBFFI_LIBS=\"-L/opt/local/lib -lffi\""
 	@exit 1
 else:
 test-libffi:
