=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
 XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 12),
  libffi-dev,
- libounit-ocaml-dev,
  ocaml-findlib,
  ocaml-nox (>= 4.00.0),
- liblwt-ocaml-dev,
+ libintegers-ocaml-dev,
  dh-ocaml
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-ctypes.git
+Standards-Version: 4.4.0
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
 Homepage: https://github.com/ocamllabs/ocaml-ctypes
 
 Package: libctypes-ocaml
