=== debian/rules ===
--- 
+++ 
@@ -15,13 +15,15 @@
 export OCAMLFIND_LDCONF
 
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml --no-parallel
 
 .PHONY: override_dh_auto_install
 override_dh_auto_install:
 	mkdir -p $(OCAMLFIND_DESTDIR) $(DESTDIR)/$(OCAML_DLL_DIR)
 	dh_auto_install
 
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing -X.so.owner -XCHANGES.md
+override_dh_missing:
+	dh_missing --fail-missing -X.so.owner -XCHANGES.md
+
+override_dh_auto_test:
+# needs lwt >= 3.2.0
