## ocaml-ctypes 0.17.1

=== debian/changelog ===
ocaml-ctypes (0.17.1-2build3) groovy; urgency=medium

  * No change rebuild against new ocaml ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Aug 2020 12:21:55 +0100

ocaml-ctypes (0.17.1-2build2) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 24 Aug 2020 20:12:14 +0100

ocaml-ctypes (0.17.1-2build1) groovy; urgency=medium

  * No change rebuild against new libffi ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Aug 2020 13:41:31 +0100

ocaml-ctypes (0.17.1-2) unstable; urgency=medium

  * Link libtest_functions.so with -lm (fixes FTBFS on some architectures)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 05 Aug 2020 17:29:30 +0200

ocaml-ctypes (0.17.1-1) unstable; urgency=medium

  * New upstream release
  * Enable upstream build-time tests
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Wed, 05 Aug 2020 13:01:22 +0200
