=== debian/control ===
--- 
+++ 
@@ -5,13 +5,16 @@
 XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  libffi-dev,
  ocaml-findlib,
- ocaml-nox (>= 4.00.0),
+ ocaml-nox,
  libintegers-ocaml-dev,
+ libounit-ocaml-dev,
+ liblwt-ocaml-dev (>= 3.2.0),
  dh-ocaml
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
 Homepage: https://github.com/ocamllabs/ocaml-ctypes
