## ocaml-ctypes 0.20.0

=== debian/changelog ===
ocaml-ctypes (0.20.0-1build2) kinetic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 May 2022 15:54:27 +0200

ocaml-ctypes (0.20.0-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jan 2022 10:40:01 +0100

ocaml-ctypes (0.20.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 17 Dec 2021 15:46:57 +0100

ocaml-ctypes (0.19.1-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release
  * Bump Standards-Version to 4.6.0

  [ Helmut Grohne ]
  * Annotate test dependencies <!nocheck>. (Closes: #981784)

  [ Debian Janitor ]
  * Update watch file format version to 4
  * Set upstream metadata fields

 -- Stéphane Glondu <glondu@debian.org>  Sun, 28 Nov 2021 17:23:15 +0100
