=== debian/changelog ===
ocaml-ctypes (0.20.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 21 Jan 2023 10:12:58 +0100
