=== debian/rules ===
--- 
+++ 
@@ -25,5 +25,4 @@
 override_dh_missing:
 	dh_missing --fail-missing -X.so.owner -XCHANGES.md
 
-override_dh_auto_test:
-# needs lwt >= 3.2.0
+override_dh_dwz:
