=== debian/watch ===
version=4
https://github.com/ocamllabs/ocaml-ctypes/releases .*/(?:ocaml-ctypes-)?(.*)\.tar\.gz
