## ocaml-ctypes 0.21.1

=== debian/changelog ===
ocaml-ctypes (0.21.1-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 16:04:43 +0100

ocaml-ctypes (0.21.1-1) unstable; urgency=medium

  * New upstream release
  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jul 2023 13:00:59 +0200

ocaml-ctypes (0.20.2-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2023 08:38:22 +0200
