## ocaml-ctypes 0.22.0

=== debian/changelog ===
ocaml-ctypes (0.22.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Jun 2024 06:13:51 +0200
