## ocaml-ctypes 0.23.0

=== debian/changelog ===
ocaml-ctypes (0.23.0-2) unstable; urgency=medium

  * Team upload.
  * Build ctypes-foreign
  * Add autopkgtests
  * Bump Standards-Version to 4.7.2 (no change)

 -- Kyle Robbertze <paddatrapper@debian.org>  Tue, 04 Nov 2025 17:06:05 +0000

ocaml-ctypes (0.23.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 29 Aug 2024 06:15:26 +0200
