=== debian/control ===
--- 
+++ 
@@ -6,14 +6,15 @@
 Build-Depends:
  debhelper-compat (= 13),
  libffi-dev,
- ocaml-findlib,
- ocaml-nox,
+ ocaml-dune,
+ libdune-ocaml-dev,
+ ocaml,
  libbigarray-compat-ocaml-dev,
  libintegers-ocaml-dev,
  libounit-ocaml-dev <!nocheck>,
  liblwt-ocaml-dev (>= 3.2.0) <!nocheck>,
- dh-ocaml
-Standards-Version: 4.6.0
+ dh-ocaml (>= 1.2)
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-ctypes.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-ctypes
@@ -39,6 +40,7 @@
 Package: libctypes-ocaml-dev
 Architecture: any
 Depends:
+ libffi-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
