=== debian/tests/control ===
Tests: upstream
Depends: ocaml-dune, libounit-ocaml-dev, libdune-ocaml-dev, liblwt-ocaml-dev, @
Restrictions: allow-stderr
