=== debian/watch ===
version=4
https://github.com/yallop/ocaml-ctypes/tags .*/v?(.*)\.tar\.gz
