## ocaml-ctypes 0.24.0

=== debian/changelog ===
ocaml-ctypes (0.24.0-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Jan 2026 00:34:06 +0100

ocaml-ctypes (0.24.0-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 28 Nov 2025 09:31:01 +0100
