=== debian/watch ===
Version: 5

Source: https://github.com/yallop/ocaml-ctypes/tags
Matching-Pattern: .*/v?(.*)\.tar\.gz
